#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>

#define N (256/4)
#define SIZE 4096

int main()
{
    int i,k;
    unsigned char *mem = mmap(0, N*SIZE, PROT_READ|PROT_WRITE,
  	MAP_PRIVATE|MAP_ANONYMOUS, 0, 0);
    if(mem == MAP_FAILED)
    	perror("mmap");
    memset(mem, 'a', N*SIZE); /* force page clearing */
    mem[N*SIZE-1]='c';
    //for(i = 0; i < N; i++) mem[i*SIZE] = i; /* force page clearing */

    for(k = 0; k < 5000; k++) {
	int pid;
	pid = fork();
	if(pid == 0) {
    	    /* child */
    	    for(i = 0; i < N; i++)
    	        mem[i*SIZE+1] = 'b';          /* force copy */
    	    //printf("copy complete\n");
	    strchr(mem, 'c') == mem+N*SIZE-1 || printf("BUG\n");	/* read all */
    	    exit(0);
	} else if(pid == -1) {
    	    perror("fork");
	} else {
    	    /* parent */
    	    waitpid(pid, NULL, 0);
	}
    }
    munmap(mem, N*SIZE);
}
