/*
* linux/arch/i386/lib/sse.c
*
* Copyright 2004 Jens Maurer
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
* Send feedback to <Jens.Maurer@gmx.net>
*/

#include <linux/preempt.h>	/* preempt_disable */
#include <asm/page.h>		/* PAGE_SIZE */
#include <asm/system.h>		/* cr0 ops */
#include <asm/i387.h>		/* kernel_fpu_start/end() */

#define FUNC(a) a##_apn
#undef ALIGN
#undef PREFETCH
#undef NT
#include "page_exp.c"

#define FUNC(a) a##_Apn
#define ALIGN
#undef PREFETCH
#undef NT
#include "page_exp.c"

#define FUNC(a) a##_aPn
#undef ALIGN
#define PREFETCH
#undef NT
#include "page_exp.c"

#define FUNC(a) a##_APn
#define ALIGN
#define PREFETCH
#undef NT
#include "page_exp.c"


#define FUNC(a) a##_apN
#undef ALIGN
#undef PREFETCH
#define NT
#include "page_exp.c"

#define FUNC(a) a##_ApN
#define ALIGN
#undef PREFETCH
#define NT
#include "page_exp.c"

#define FUNC(a) a##_aPN
#undef ALIGN
#define PREFETCH
#define NT
#include "page_exp.c"

#define FUNC(a) a##_APN
#define ALIGN
#define PREFETCH
#define NT
#include "page_exp.c"
